﻿XIncludeFile "..\HID_Module.pbi"

#USB_VID = $1610
#USB_PID = $2016

Structure SendStruct
  Report.a
  SendArray.u[15]
  Reserved.u
EndStructure

Global gUSBSend.SendStruct\Report=0, USB_hDevice=0

Procedure Send(Pos, Param.u)
  If USB_hDevice
    
    gUSBSend\SendArray[Pos] = Param
    
    If HID::WriteDevice(USB_hDevice, @gUSBSend, SizeOf(SendStruct)) <> SizeOf(SendStruct)
      MessageRequester("", "Ошибка при передаче данных")
    EndIf
    
  EndIf
EndProcedure


Procedure FindDevice_Timer()
  Static Old_Test=-1
  
  Test=HID::TestDevice(#USB_PID, #USB_VID)
  If Test<>Old_Test
    Old_Test=Test
    If Test 
      HID::CloseDevice(USB_hDevice)
      USB_hDevice=HID::OpenDevice(#USB_PID, #USB_VID)
      SetGadgetText(100, "Связь с USB устройством установлена")
      SetGadgetColor(100, #PB_Gadget_FrontColor, RGB(0, 128, 0))
    Else
      HID::CloseDevice(USB_hDevice)
      USB_hDevice=0
      SetGadgetText(100, "Нет связи с USB устройством")
      SetGadgetColor(100, #PB_Gadget_FrontColor, RGB(128, 0, 0))
    EndIf
  EndIf

EndProcedure

OpenWindow(0, 0, 0, 310, 458, "ШИМ Тест",#PB_Window_MinimizeGadget|#PB_Window_Invisible|#PB_Window_ScreenCentered)

#PosX = 2
#PosY = 30
#Step = 28

TextGadget(100, #PosX+24, 4, 280, 16, "")

For i=0 To 14
  TextGadget(#PB_Any, #PosX, #PosY+i*#Step+4, 20, 16, Str(i+1), #PB_Text_Right)
  TrackBarGadget(i, #PosX+24, #PosY+i*#Step, 250, 24, 0, 4095)
  TextGadget(i+15, #PosX+24+252, #PosY+i*#Step+4, 50, 16, "0")
Next i

AddWindowTimer(0, 0, 500)
HideWindow(0, 0)

Repeat
  Event = WaitWindowEvent()
  
  If Event = #PB_Event_Gadget
    
    Gadget = EventGadget()
    If Gadget>=0 And Gadget<=14
      State = GetGadgetState(Gadget)
      SetGadgetText(Gadget+15, Str(State))
      Send(Gadget, State)
    EndIf
    
  ElseIf #PB_Event_Timer
    FindDevice_Timer()
  EndIf
  
Until Event = #PB_Event_CloseWindow

; IDE Options = PureBasic 5.44 LTS (Windows - x86)
; CursorPosition = 81
; FirstLine = 41
; Folding = -
; EnableUnicode
; EnableXP
; Executable = Test.exe
; CompileSourceDirectory